Index: XIOS/dev/dev_olga/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS/dev/dev_olga/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 983)
+++ XIOS/dev/dev_olga/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 1158)
@@ -14,6 +14,6 @@
     ( filegroup_id, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -44,7 +44,12 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_units
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: timeseries
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: ts_prefix
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_name
 
       CALL xios(get_filegroup_handle) &
@@ -53,6 +58,6 @@
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(set_filegroup_attr)
@@ -61,6 +66,6 @@
     ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -90,13 +95,18 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_units
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: timeseries
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: ts_prefix
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_name
 
       CALL xios(set_filegroup_attr_hdl_)  &
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(set_filegroup_attr_hdl)
@@ -106,5 +116,6 @@
     , group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_  &
     , record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
-    , timeseries_, ts_prefix_, type_ )
+    , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
+    , uuid_name_ )
 
     IMPLICIT NONE
@@ -134,7 +145,12 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_name_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_stamp_name_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_units_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: timeseries_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: ts_prefix_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: uuid_name_
 
       IF (PRESENT(append_)) THEN
@@ -246,4 +262,19 @@
       ENDIF
 
+      IF (PRESENT(time_stamp_format_)) THEN
+        CALL cxios_set_filegroup_time_stamp_format &
+      (filegroup_hdl%daddr, time_stamp_format_, len(time_stamp_format_))
+      ENDIF
+
+      IF (PRESENT(time_stamp_name_)) THEN
+        CALL cxios_set_filegroup_time_stamp_name &
+      (filegroup_hdl%daddr, time_stamp_name_, len(time_stamp_name_))
+      ENDIF
+
+      IF (PRESENT(time_units_)) THEN
+        CALL cxios_set_filegroup_time_units &
+      (filegroup_hdl%daddr, time_units_, len(time_units_))
+      ENDIF
+
       IF (PRESENT(timeseries_)) THEN
         CALL cxios_set_filegroup_timeseries &
@@ -261,4 +292,14 @@
       ENDIF
 
+      IF (PRESENT(uuid_format_)) THEN
+        CALL cxios_set_filegroup_uuid_format &
+      (filegroup_hdl%daddr, uuid_format_, len(uuid_format_))
+      ENDIF
+
+      IF (PRESENT(uuid_name_)) THEN
+        CALL cxios_set_filegroup_uuid_name &
+      (filegroup_hdl%daddr, uuid_name_, len(uuid_name_))
+      ENDIF
+
   END SUBROUTINE xios(set_filegroup_attr_hdl_)
 
@@ -266,6 +307,6 @@
     ( filegroup_id, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -296,7 +337,12 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_units
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: timeseries
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: ts_prefix
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_name
 
       CALL xios(get_filegroup_handle) &
@@ -305,6 +351,6 @@
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(get_filegroup_attr)
@@ -313,6 +359,6 @@
     ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -342,13 +388,18 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_name
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_units
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: timeseries
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: ts_prefix
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_format
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_name
 
       CALL xios(get_filegroup_attr_hdl_)  &
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(get_filegroup_attr_hdl)
@@ -358,5 +409,6 @@
     , group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_  &
     , record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
-    , timeseries_, ts_prefix_, type_ )
+    , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
+    , uuid_name_ )
 
     IMPLICIT NONE
@@ -386,7 +438,12 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_name_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_stamp_name_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_units_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: timeseries_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: ts_prefix_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_format_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: uuid_name_
 
       IF (PRESENT(append_)) THEN
@@ -498,4 +555,19 @@
       ENDIF
 
+      IF (PRESENT(time_stamp_format_)) THEN
+        CALL cxios_get_filegroup_time_stamp_format &
+      (filegroup_hdl%daddr, time_stamp_format_, len(time_stamp_format_))
+      ENDIF
+
+      IF (PRESENT(time_stamp_name_)) THEN
+        CALL cxios_get_filegroup_time_stamp_name &
+      (filegroup_hdl%daddr, time_stamp_name_, len(time_stamp_name_))
+      ENDIF
+
+      IF (PRESENT(time_units_)) THEN
+        CALL cxios_get_filegroup_time_units &
+      (filegroup_hdl%daddr, time_units_, len(time_units_))
+      ENDIF
+
       IF (PRESENT(timeseries_)) THEN
         CALL cxios_get_filegroup_timeseries &
@@ -513,4 +585,14 @@
       ENDIF
 
+      IF (PRESENT(uuid_format_)) THEN
+        CALL cxios_get_filegroup_uuid_format &
+      (filegroup_hdl%daddr, uuid_format_, len(uuid_format_))
+      ENDIF
+
+      IF (PRESENT(uuid_name_)) THEN
+        CALL cxios_get_filegroup_uuid_name &
+      (filegroup_hdl%daddr, uuid_name_, len(uuid_name_))
+      ENDIF
+
   END SUBROUTINE xios(get_filegroup_attr_hdl_)
 
@@ -518,6 +600,6 @@
     ( filegroup_id, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -566,4 +648,10 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_name
       LOGICAL(KIND=C_BOOL) :: time_counter_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_format
+      LOGICAL(KIND=C_BOOL) :: time_stamp_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_name
+      LOGICAL(KIND=C_BOOL) :: time_stamp_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_units
+      LOGICAL(KIND=C_BOOL) :: time_units_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: timeseries
       LOGICAL(KIND=C_BOOL) :: timeseries_tmp
@@ -572,4 +660,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_format
+      LOGICAL(KIND=C_BOOL) :: uuid_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_name
+      LOGICAL(KIND=C_BOOL) :: uuid_name_tmp
 
       CALL xios(get_filegroup_handle) &
@@ -578,6 +670,6 @@
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(is_defined_filegroup_attr)
@@ -586,6 +678,6 @@
     ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
     , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-    , type )
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+    , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
     IMPLICIT NONE
@@ -633,4 +725,10 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_name
       LOGICAL(KIND=C_BOOL) :: time_counter_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_format
+      LOGICAL(KIND=C_BOOL) :: time_stamp_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_name
+      LOGICAL(KIND=C_BOOL) :: time_stamp_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_units
+      LOGICAL(KIND=C_BOOL) :: time_units_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: timeseries
       LOGICAL(KIND=C_BOOL) :: timeseries_tmp
@@ -639,10 +737,14 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_format
+      LOGICAL(KIND=C_BOOL) :: uuid_format_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_name
+      LOGICAL(KIND=C_BOOL) :: uuid_name_tmp
 
       CALL xios(is_defined_filegroup_attr_hdl_)  &
       ( filegroup_hdl, append, compression_level, convention, cyclic, description, enabled, format  &
       , group_ref, min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
-      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
-      , type )
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, time_stamp_format  &
+      , time_stamp_name, time_units, timeseries, ts_prefix, type, uuid_format, uuid_name )
 
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl)
@@ -652,5 +754,6 @@
     , group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_  &
     , record_offset_, split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_  &
-    , timeseries_, ts_prefix_, type_ )
+    , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
+    , uuid_name_ )
 
     IMPLICIT NONE
@@ -698,4 +801,10 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_name_
       LOGICAL(KIND=C_BOOL) :: time_counter_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_format_
+      LOGICAL(KIND=C_BOOL) :: time_stamp_format__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_stamp_name_
+      LOGICAL(KIND=C_BOOL) :: time_stamp_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_units_
+      LOGICAL(KIND=C_BOOL) :: time_units__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: timeseries_
       LOGICAL(KIND=C_BOOL) :: timeseries__tmp
@@ -704,4 +813,8 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_format_
+      LOGICAL(KIND=C_BOOL) :: uuid_format__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_name_
+      LOGICAL(KIND=C_BOOL) :: uuid_name__tmp
 
       IF (PRESENT(append_)) THEN
@@ -831,4 +944,22 @@
       ENDIF
 
+      IF (PRESENT(time_stamp_format_)) THEN
+        time_stamp_format__tmp = cxios_is_defined_filegroup_time_stamp_format &
+      (filegroup_hdl%daddr)
+        time_stamp_format_ = time_stamp_format__tmp
+      ENDIF
+
+      IF (PRESENT(time_stamp_name_)) THEN
+        time_stamp_name__tmp = cxios_is_defined_filegroup_time_stamp_name &
+      (filegroup_hdl%daddr)
+        time_stamp_name_ = time_stamp_name__tmp
+      ENDIF
+
+      IF (PRESENT(time_units_)) THEN
+        time_units__tmp = cxios_is_defined_filegroup_time_units &
+      (filegroup_hdl%daddr)
+        time_units_ = time_units__tmp
+      ENDIF
+
       IF (PRESENT(timeseries_)) THEN
         timeseries__tmp = cxios_is_defined_filegroup_timeseries &
@@ -849,4 +980,16 @@
       ENDIF
 
+      IF (PRESENT(uuid_format_)) THEN
+        uuid_format__tmp = cxios_is_defined_filegroup_uuid_format &
+      (filegroup_hdl%daddr)
+        uuid_format_ = uuid_format__tmp
+      ENDIF
+
+      IF (PRESENT(uuid_name_)) THEN
+        uuid_name__tmp = cxios_is_defined_filegroup_uuid_name &
+      (filegroup_hdl%daddr)
+        uuid_name_ = uuid_name__tmp
+      ENDIF
+
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl_)
 